import random
random.seed("basic04/warriors")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2, 3])
        self.print_test([1, 1, 2])
                                 
    def generate_min_tests(self):
        self.print_test([1])
        self.print_test([2, 1])
        self.print_test([1, 2])
                          
    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn):
        a = []
        n = random.randint(2, maxn)
        if (random.randint(1, 2) == 1) and (n % 2 == 1):
            n -= 1
        ones = random.randint(1, n // 2)
        for i in range(ones):
            a.append(1)
        for i in range(n - ones):
            a.append(random.randint(2, 3))
        random.shuffle(a)
        self.print_test(a)

    def generate_only_equals_test(self, n, x):
        a = [x for i in range(n)]
        self.print_test(a)

    def generate_max_tests(self, maxn):
        a = []
        for i in range(maxn // 2):
            a.append(1)
        for i in range(maxn // 2):
            a.append(random.randint(2, 3))
        random.shuffle(a)
        self.print_test(a)

        a = []
        for i in range(maxn // 2 - 1):
            a.append(1)
        for i in range(maxn // 2 + 1):
            a.append(random.randint(2, 3))
        random.shuffle(a)
        self.print_test(a)

    def print_test(self, a):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), file=test_file)
        print(' '.join(str(element) for element in a), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        maxn = 10**5
        ns = [3, 5, 10, 100, 1000, 10**4, maxn // 2, maxn]
        for n in ns:
            for i in range(5):
                self.generate_random_test(n)
        for x in range(1, 4):
            self.generate_only_equals_test(maxn, x)
        self.generate_max_tests(maxn)

    def generate_all_tests_argv(self, argv):
        pass            

if __name__ == "__main__":
    import os, shutil
    from sys import argv
    if os.path.exists('../tests'):
        print('Directory <<tests>> already exists')
        shutil.rmtree('../tests', ignore_errors=False, onerror=None)
    try:
        os.makedirs('../tests')
    except OSError:
        pass

    import time
    start = time.time()
    writer = TestGen()
    writer.generate_all_tests()
    #writer.generate_all_tests_argv(argv)
    finish = time.time()
    print('All tests were generated. Elapsed time: ', finish - start)
